# TMail Υإåǥɤ MIME ˽褦ˤ롣
# $Id: tmail+.rb,v 1.3 2000/03/06 14:24:50 tommy Exp $

class Bencode

  def Bencode.decode(str, outcode = '-e')
    ret = ''
    blank = ''
    f = false	# Is prev token "=?.?..?=" ?
    str.split(/(\s+)/).each do |s|
      if s =~ /^\s+$/
	blank = ' '
      else
	begin
	  s0 = decode_header_token s
	  if s0 == s then
	    ret << blank + s
	    f = false
	  else
	    ret << if f then s0 else blank + s0 end
	    f = true
	  end
	rescue
	  $stderr.puts "#{$!}: in #{s}"
	  ret << s
	end
	blank = ''
      end
    end
    ret + blank
  end

  # ȡMIMEǥɤ
  #
  def Bencode.decode_header_token(str)
    if str =~ /\A\=\?([^?]+)\?(b|q)\?([^?]*)\?\=\z/io then
      codeset, encode, msg = $1, $2, $3
      m = case encode.downcase
	  when 'b' then Base64.hdecode msg
	  when 'q' then QuotedPrintable.hdecode msg
	  else raise "unkown encode '#{encode}'"
	  end
      m = case codeset.downcase
	  when 'us-ascii', 'euc-jp' then m
	  when 'iso-2022-jp' then NKF::nkf('-m0Je', m)
	  when 'shift_jis' then NKF::nkf('-m0Se', m)
	  else raise "unkown codeset '#{codeset}'"
	  end
      m
    else
      str
    end
  end

end

