# Base64 & QuotedPrintable $B%G%3!<%@(B
# $Id: w3ml_mime.rb,v 1.2 2000/03/10 13:55:39 tommy Exp $

class Base64
  # B$B%(%s%3!<%I$5$l$?%X%C%@J8;zNs$r%G%3!<%I$9$k(B
  def Base64.hdecode(str)
    str.unpack('m')[0]
  end

  # Base64 $B%G%3!<%I(B
  def Base64.decode(str)
    Base64.hdecode str
  end
end

class QuotedPrintable
  # Q$B%(%s%3!<%I$5$l$?%X%C%@J8;zNs$r%G%3!<%I$9$k(B
  def QuotedPrintable.hdecode(str)
    str.gsub('_', ' ').gsub(/=([0-9A-F][0-9A-F])/) do $1.hex.chr end
  end

  # QuotedPrintable $B%G%3!<%I(B
  def QuotedPrintable.decode(str)
    str.gsub(/\r\n/, "\n").gsub(/[ \t]+$/, '').gsub(/=\n/, '').
      gsub(/=([0-9A-F][0-9A-F])/) do $1.hex.chr end
  end
end
